// ----------------------------------------------------------------------------
//
// sumie.vsh
//
//    Copyright (c) 2002 imagire takashi (imagire@nifty.com) All Rights Reserved.
//
// ----------------------------------------------------------------------------
//
// ; Hand assembled shader
// vs.1.0
//
// mov oPos, v0
//
// add oT0, v7, c20
// add oT1, v7, c21
// add oT2, v7, c22
// add oT3, v7, c23


// ----------------------------------------------------------------------------
// Input
// ----------------------------------------------------------------------------
struct appdata : application2vertex {
    float4 Position;
	float2 Texcoord;
};

// ----------------------------------------------------------------------------
// Output
// ----------------------------------------------------------------------------
#pragma bind vfconn.Position  = HPOS;
#pragma bind vfconn.Texcoord0 = TEX0;
#pragma bind vfconn.Texcoord1 = TEX1;
#pragma bind vfconn.Texcoord2 = TEX2;
#pragma bind vfconn.Texcoord3 = TEX3;

struct vfconn : vertex2fragment {
    float4 Position;
    float2 Texcoord0;
    float2 Texcoord1;
    float2 Texcoord2;
    float2 Texcoord3;
};
// ----------------------------------------------------------------------------
// Vertex Shader Program
// ----------------------------------------------------------------------------
vfconn main(appdata IN
        , uniform float2 const_texcoord0
        , uniform float2 const_texcoord1
        , uniform float2 const_texcoord2
        , uniform float2 const_texcoord3
) {
    vfconn OUT;

    /////////////////////////////////////////////////////////////////////
    // Position
    OUT.Position = IN.Position;       // Just copy input value

    /////////////////////////////////////////////////////////////////////
    // Texture
    OUT.Texcoord0 = IN.Texcoord + const_texcoord0;   // Copy constant value
    OUT.Texcoord1 = IN.Texcoord + const_texcoord1;   // Copy constant value
    OUT.Texcoord2 = IN.Texcoord + const_texcoord2;   // Copy constant value
    OUT.Texcoord3 = IN.Texcoord + const_texcoord3;   // Copy constant value

    return OUT;
}
